commit 20c180cf65e81257d40d6e0f3d798b5ec5364b11
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Oct 22 20:30:41 2024 +0200

    c-family: Fix up -Wsizeof-pointer-memaccess ICEs [PR117230]
    
    In the following testcases, we ICE on all 4 function calls.
    The problem is using TYPE_PRECISION on vector types (but guess it
    would be similarly problematic on structures/unions/arrays).
    The test only differentiates between suggestion what to do, whether
    to supply explicit size because sizeof (*p) for
    {,{,un}signed }char *p is not very likely what the user want, or
    dereferencing the pointer, so I think limiting that suggestion
    to integral types is ok.
    
    2024-10-22  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/117230
            * c-warn.cc (sizeof_pointer_memaccess_warning): Only compare
            TYPE_PRECISION of TREE_TYPE (type) to precision of char if
            TREE_TYPE (type) is integral type.
    
            * c-c++-common/Wsizeof-pointer-memaccess5.c: New test.
    
    (cherry picked from commit 5fd1c0c1b6968d55e3f997d67a4c149edf20c012)

diff --git a/gcc/c-family/c-warn.cc b/gcc/c-family/c-warn.cc
index 8fc0d8a53b3..63c8187c4e5 100644
--- a/gcc/c-family/c-warn.cc
+++ b/gcc/c-family/c-warn.cc
@@ -944,8 +944,9 @@ sizeof_pointer_memaccess_warning (location_t *sizeof_arg_loc, tree callee,
 			"argument to %<sizeof%> in %qD call is the same "
 			"expression as the destination; did you mean to "
 			"remove the addressof?", callee);
-	  else if ((TYPE_PRECISION (TREE_TYPE (type))
-		    == TYPE_PRECISION (char_type_node))
+	  else if ((INTEGRAL_TYPE_P (TREE_TYPE (type))
+		    && (TYPE_PRECISION (TREE_TYPE (type))
+			== TYPE_PRECISION (char_type_node)))
 		   || strop)
 	    warning_at (loc, OPT_Wsizeof_pointer_memaccess,
 			"argument to %<sizeof%> in %qD call is the same "
@@ -984,8 +985,9 @@ sizeof_pointer_memaccess_warning (location_t *sizeof_arg_loc, tree callee,
 			"argument to %<sizeof%> in %qD call is the same "
 			"expression as the source; did you mean to "
 			"remove the addressof?", callee);
-	  else if ((TYPE_PRECISION (TREE_TYPE (type))
-		    == TYPE_PRECISION (char_type_node))
+	  else if ((INTEGRAL_TYPE_P (TREE_TYPE (type))
+		    && (TYPE_PRECISION (TREE_TYPE (type))
+			== TYPE_PRECISION (char_type_node)))
 		   || strop)
 	    warning_at (loc, OPT_Wsizeof_pointer_memaccess,
 			"argument to %<sizeof%> in %qD call is the same "
@@ -1024,8 +1026,9 @@ sizeof_pointer_memaccess_warning (location_t *sizeof_arg_loc, tree callee,
 			"argument to %<sizeof%> in %qD call is the same "
 			"expression as the first source; did you mean to "
 			"remove the addressof?", callee);
-	  else if ((TYPE_PRECISION (TREE_TYPE (type))
-		    == TYPE_PRECISION (char_type_node))
+	  else if ((INTEGRAL_TYPE_P (TREE_TYPE (type))
+		    && (TYPE_PRECISION (TREE_TYPE (type))
+			== TYPE_PRECISION (char_type_node)))
 		   || strop)
 	    warning_at (loc, OPT_Wsizeof_pointer_memaccess,
 			"argument to %<sizeof%> in %qD call is the same "
@@ -1064,8 +1067,9 @@ sizeof_pointer_memaccess_warning (location_t *sizeof_arg_loc, tree callee,
 			"argument to %<sizeof%> in %qD call is the same "
 			"expression as the second source; did you mean to "
 			"remove the addressof?", callee);
-	  else if ((TYPE_PRECISION (TREE_TYPE (type))
-		    == TYPE_PRECISION (char_type_node))
+	  else if ((INTEGRAL_TYPE_P (TREE_TYPE (type))
+		    && (TYPE_PRECISION (TREE_TYPE (type))
+			== TYPE_PRECISION (char_type_node)))
 		   || strop)
 	    warning_at (loc, OPT_Wsizeof_pointer_memaccess,
 			"argument to %<sizeof%> in %qD call is the same "
diff --git a/gcc/testsuite/c-c++-common/Wsizeof-pointer-memaccess5.c b/gcc/testsuite/c-c++-common/Wsizeof-pointer-memaccess5.c
new file mode 100644
index 00000000000..aaa7da04a2c
--- /dev/null
+++ b/gcc/testsuite/c-c++-common/Wsizeof-pointer-memaccess5.c
@@ -0,0 +1,29 @@
+/* PR c/117230 */
+/* { dg-do compile } */
+/* { dg-options "-Wsizeof-pointer-memaccess" } */
+
+typedef int V __attribute__((vector_size (sizeof (int))));
+
+void
+foo (V *a, char *b)
+{
+  __builtin_memcpy (b, a, sizeof (a));		/* { dg-warning "argument to 'sizeof' in '\[^\n\r]*__builtin_memcpy\[^\n\r]*' call is the same expression as the source; did you mean to dereference it\\\?" } */
+}
+
+void
+bar (V *a, char *b)
+{
+  __builtin_memcpy (a, b, sizeof (a));		/* { dg-warning "argument to 'sizeof' in '\[^\n\r]*__builtin_memcpy\[^\n\r]*' call is the same expression as the destination; did you mean to dereference it\\\?" } */
+}
+
+int
+baz (V *a, char *b)
+{
+  return __builtin_memcmp (a, b, sizeof (a));	/* { dg-warning "argument to 'sizeof' in '\[^\n\r]*__builtin_memcmp\[^\n\r]*' call is the same expression as the first source; did you mean to dereference it\\\?" } */
+}
+
+int
+qux (V *a, char *b)
+{
+  return __builtin_memcmp (b, a, sizeof (a));	/* { dg-warning "argument to 'sizeof' in '\[^\n\r]*__builtin_memcmp\[^\n\r]*' call is the same expression as the second source; did you mean to dereference it\\\?" } */
+}

